library ieee;
use ieee.std_logic_1164.all;

entity tb_elabora is
end tb_elabora;

architecture tb_elabora of tb_elabora is
component elabora is
	port (dato: in std_logic_vector(7 downto 0);
	       op: in std_logic_vector(1 downto 0);
		   clk, start: in std_logic;
		   ris: out std_logic_vector(7 downto 0));
end component;

signal dato, ris : std_logic_vector( 7 downto 0);
signal op: std_logic_vector( 1 downto 0);
signal clk,start: std_logic;

begin
	dut: elabora port map (dato,op,clk,start,ris);
	
	process
	begin
		clk <= '0';
		wait for 5 ns;
		clk <= '1';
		wait for 5 ns;
	end process;
	
	process
	begin
		start <= '0';
		wait for 1 ns;
		start <= '1';
		wait for 10 ns;
		start <= '0';
		wait for 50 ns;
	end process;
	
	op <= "00" after 0 ns, "01" after 60 ns, "10" after 120 ns, "11" after 180 ns;
	
	dato <= "00000001" after 11 ns, "00000011" after 21 ns,
	"00001101" after 71 ns, "00000010" after 81 ns,
	"00000111" after 131 ns, "00000011" after 141 ns,
	"00000001" after 191 ns, "00000110" after 201 ns;
end tb_elabora;
