library ieee;
use ieee.std_logic_1164.all;
use work.miopack.all;

entity elabora is
	port (dato: in std_logic_vector(7 downto 0);
	       op: in std_logic_vector(1 downto 0);
		   clk, start: in std_logic;
		   ris: out std_logic_vector(7 downto 0));
end elabora;

architecture beh of elabora is	

signal end0,end1,enop: std_logic; 
type stati is (idle, letd0,letd1,esegui); 
signal s: stati;
signal d0,d1: std_logic_vector(7 downto 0);
signal oper: std_logic_vector( 1 downto 0);

begin
--cu
  process(clk) 
	
	begin
		if clk'event and clk='0' then
			case s is
				when idle => if start = '1' then s <= letd0;
						else s <= idle;
				        end if;
				when letd0 => s<=letd1;
				when letd1 => s<=esegui;
				when esegui => s<= idle;
				when others => s<= idle;
		   end case;
		   end if;
		end process;
		
	end0 <= '1' when s = letd0 else
		    '0';
	end1 <= '1' when s = letd1 else
		   '0';
    enop <= '1' when s = esegui else 
		'0';
		
		
		
	-- datapath	
	process(clk)
	 variable  tmp:  std_logic_vector(7 downto 0);
	begin
		if clk'event and clk='0' then
			if end0= '1' then  d0<= dato;
				                oper <= op;
			end if;
			if end1 = '1' then d1 <= dato;
			end if;
			if enop = '1' then
				alu(d0,d1,oper,ris);
				
		 end if;
	 end if;
	end process;   
	
end beh;